From e86e9b14bff02935fcadb4758c4350816dcf6862 Mon Sep 17 00:00:00 2001
From: David Carlos <ddavidcarlos1392@gmail.com>
Date: Mar 16 2018 02:30:30 +0000
Subject: [PATCH 11/17] Fix remaining tests.


---

diff --git a/Makefile b/Makefile
index cffabee..fcc2240 100644
--- a/Makefile
+++ b/Makefile
@@ -2,22 +2,22 @@
 SHELL:=/bin/bash
 
 help:
-	@printf "Available targets: check, analyzers, clean\n\n"
+	@printf "Available targets: test, analyzers, clean\n\n"
 
-check:
+test:
 	coverage run --omit="lib/*","setup.py","kiskadee/tests/*",".eggs/*",".venv/*","/usr/*" -m unittest kiskadee/tests/*/*.py
 	coverage html
 
-check_units:
+test_units:
 	python3 -m unittest kiskadee/tests/units/*.py
 
-check_integration:
+test_integration:
 	python3 -m unittest kiskadee/tests/integration/*.py
 
-check_api:
+test_api:
 	python3 -m unittest kiskadee/tests/api/*.py
 
-check_plugins:
+test_plugins:
 	python3 -m unittest kiskadee/tests/plugins/*.py
 
 analyzers:
diff --git a/kiskadee/api/app.py b/kiskadee/api/app.py
index f484bc4..9eb7b3a 100644
--- a/kiskadee/api/app.py
+++ b/kiskadee/api/app.py
@@ -14,13 +14,13 @@ kiskadee = Flask(__name__)
 
 CORS(kiskadee)
 
+db = Database()
 
 @kiskadee.route('/fetchers')
 def index():
     """Get the list of available fetchers."""
     if request.method == 'GET':
-        db_session = kiskadee_db_session()
-        fetchers = db_session.query(Fetcher).all()
+        fetchers = db.session.query(Fetcher).all()
         fetcher_schema = FetcherSchema(many=True)
         result = fetcher_schema.dump(fetchers)
         return jsonify({'fetchers': result.data})
@@ -30,8 +30,7 @@ def index():
 def packages():
     """Get the list of analyzed packages."""
     if request.method == 'GET':
-        db_session = kiskadee_db_session()
-        packages = db_session.query(Package).all()
+        packages = db.session.query(Package).all()
         package_schema = PackageSchema(
             many=True,
             exclude=['versions.analysis', 'versions.package_id']
@@ -42,16 +41,14 @@ def packages():
 
 @kiskadee.route('/analysis/<pkg_name>/<version>', methods=['GET'])
 def package_analysis_overview(pkg_name, version):
-    """Get the a analysis list of some package version."""
-    db_session = kiskadee_db_session()
+    """Get a analysis list of some package version."""
 
     #TODO: This can be a simple inner join between package, version and analysis
-    package_id = db_session.query(Package).filter_by(name = pkg_name).id
-    version_id = db_session.query(Version)\
-            .filter(Version.number == version)\
-            .filter(Version.package_id == package_id).first().id
+    _package_id = db.filter_by_name(Package, pkg_name).id
+    version_id = db.session.query(Version)\
+            .filter_by(number = version, package_id = _package_id ).first().id
     analysis = (
-            db_session.query(Analysis)
+            db.session.query(Analysis)
             .options(
                 eagerload(Analysis.analyzers, innerjoin=True)
             )
@@ -69,8 +66,7 @@ def package_analysis_overview(pkg_name, version):
 )
 def analysis_results(pkg_name, version, analysis_id):
     """Get the analysis results from a specific analyzer."""
-    db_session = kiskadee_db_session()
-    analysis = db_session.query(Analysis).get(analysis_id)
+    analysis = db.get(Analysis, analysis_id)
     analysis_schema = AnalysisSchema(only=['raw'])
     data, errors = analysis_schema.dump(analysis)
     response = data['raw']['results']
@@ -83,8 +79,7 @@ def analysis_results(pkg_name, version, analysis_id):
 )
 def analysis_reports(pkg_name, version, analysis_id):
     """Get the analysis reports from a specific analyzer."""
-    db_session = kiskadee_db_session()
-    analysis = db_session.query(Analysis).get(analysis_id)
+    analysis = db.get(Analysis, analysis_id)
     data, errors = AnalysisSchema(only=['report']).dump(analysis)
     report = data['report']
     try:
@@ -93,11 +88,6 @@ def analysis_reports(pkg_name, version, analysis_id):
     except Exception as err:
         return jsonify({'analysis_report': {}})
 
-
-def kiskadee_db_session():
-    """Return a kiskadee database session."""
-    return Database().session
-
 def main():
     """Initialize the kiskadee API."""
     kiskadee.run('0.0.0.0')
diff --git a/kiskadee/database.py b/kiskadee/database.py
index 945a601..96cefe4 100644
--- a/kiskadee/database.py
+++ b/kiskadee/database.py
@@ -1,9 +1,10 @@
 """Provide kiskadee Database operations."""
 
-import kiskadee
-from kiskadee.model import Base
 from sqlalchemy import create_engine, orm
 
+import kiskadee
+from kiskadee.model import Base
+from kiskadee.model import Package, Fetcher, Version, Report, Analysis
 
 class Database:
     """kiskadee Database class."""
@@ -22,6 +23,11 @@ class Database:
         DBSession = orm.sessionmaker(bind=engine)
         return DBSession()
 
+    def filter_by_name(self, model, _name):
+        return self.session.query(model).filter_by(name = _name).first()
+
+    def get(self, model, id):
+        return self.session.query(model).get(id)
 
 def get_database_uri(db):
     """Return the Database URI of the current session."""
diff --git a/kiskadee/model.py b/kiskadee/model.py
index 4e4dff2..acbd5a0 100644
--- a/kiskadee/model.py
+++ b/kiskadee/model.py
@@ -31,7 +31,7 @@ class Package(Base):
             )
 
     @staticmethod
-    def save(session, data):
+    def save(db, data):
         homepage = None
         if ('meta' in data) and ('homepage' in data['meta']):
             homepage = data['meta']['homepage']
@@ -41,16 +41,16 @@ class Package(Base):
                 homepage=homepage,
                 fetcher_id=data['fetcher_id']
                 )
-        session.add(_package)
-        session.commit()
+        db.session.add(_package)
+        db.session.commit()
         _version = Version(number=data['version'],
                            package_id=_package.id)
-        session.add(_version)
-        session.commit()
+        db.session.add(_version)
+        db.session.commit()
         return _package
 
     @staticmethod
-    def update(session, project, data):
+    def update(db, project, data):
 
         if(project.versions[-1].number == data['version']):
             return project
@@ -60,8 +60,8 @@ class Package(Base):
                     project_id=project.id
                     )
             project.versions.append(_new_version)
-            session.add(project)
-            session.commit()
+            db.session.add(project)
+            db.session.commit()
             kiskadee.logger.debug(
                     "MONITOR: Sending project {}_{}"
                     "for analysis".format(data['name'], data['version'])
@@ -109,7 +109,7 @@ class Analyzer(Base):
     analysis = orm.relationship('Analysis', backref='analyzers')
 
     @staticmethod
-    def create_analyzers(_session):
+    def create_analyzers(db):
         """Create the analyzers on database.
 
         The kiskadee analyzers are defined on the section `analyzers` of the
@@ -118,13 +118,13 @@ class Analyzer(Base):
         """
         list_of_analyzers = dict(kiskadee.config._sections["analyzers"])
         for _name, _version in list_of_analyzers.items():
-            if not _session.query(Analyzer)\
+            if not db.session.query(Analyzer)\
                             .filter_by(name = _name, version = _version )\
                             .first():
                 new_analyzer = kiskadee.model.Analyzer(name = _name,
                                                        version = _version)
-                _session.add(new_analyzer)
-        _session.commit()
+                db.session.add(new_analyzer)
+        db.session.commit()
 
 class Analysis(Base):
     """Abstraction of a package analysis."""
@@ -139,21 +139,21 @@ class Analysis(Base):
                               uselist=False, back_populates='analysis')
 
     @staticmethod
-    def save(session, data, analyzer, result, version):
+    def save(db, data, analyzer, result, version):
         _analysis = kiskadee.model.Analysis()
         try:
-            _analyzer = session.query(kiskadee.model.Analyzer).\
+            _analyzer = db.session.query(kiskadee.model.Analyzer).\
                     filter_by(name = analyzer).first()
             _analysis.analyzer_id = _analyzer.id
             _analysis.version_id = version.id
             _analysis.raw = json.loads(result)
-            session.add(_analysis)
-            session.commit()
+            db.session.add(_analysis)
+            db.session.commit()
             dict_analysis = {
                     'results': _analysis.raw['results'],
                     'id': _analysis.id
                 }
-            Report.save(session, dict_analysis, data, _analyzer.name)
+            Report.save(db, dict_analysis, data, _analyzer.name)
             kiskadee.logger.debug(
                     "MONITOR: Saved analysis done by {} for package: {}-{}"
                     .format(analyzer, data["name"], data["version"])
@@ -184,7 +184,7 @@ class Report(Base):
     analysis = orm.relationship('Analysis', back_populates='report')
 
     @staticmethod
-    def save(session, analysis, data, analyzer_name):
+    def save(db, analysis, data, analyzer_name):
         try:
             results = analysis['results']
             analyzer_report = Report.REPORTERS[analyzer_name](results)
@@ -194,8 +194,8 @@ class Report(Base):
                     ._compute_reports(analyzer_name)
                 )
             _reports.analysis_id = analysis['id']
-            session.add(_reports)
-            session.commit()
+            db.session.add(_reports)
+            db.session.commit()
             kiskadee.logger.debug(
                     "MONITOR: Saved analysis reports for {} package"
                     .format(data["name"])
diff --git a/kiskadee/monitor.py b/kiskadee/monitor.py
index 0fc6755..7f485c2 100644
--- a/kiskadee/monitor.py
+++ b/kiskadee/monitor.py
@@ -19,11 +19,11 @@ RUNNING = True
 class Monitor:
     """Provide kiskadee monitoring objects."""
 
-    def __init__(self, _session, queues):
+    def __init__(self, db, queues):
         """Return a non initialized Monitor."""
-        self.session = _session
+        self.db = db
         self.queues = queues
-        kiskadee.model.Analyzer.create_analyzers(self.session)
+        kiskadee.model.Analyzer.create_analyzers(self.db)
 
     def start(self):
         kiskadee.logger.debug('Monitor PID: {}'.format(os.getpid()))
@@ -56,8 +56,8 @@ class Monitor:
     def get_fetcher_and_project(self, data):
         fetcher_name = data['fetcher'].split('.')[-1]
         project_name = data['name']
-        fetcher = self._query(Fetcher).filter_by(name = fetcher_name).first()
-        project = self._query(Package).filter_by(name = project_name).first()
+        fetcher = self.db.filter_by_name(Fetcher, fetcher_name)
+        project = self.db.filter_by_name(Package, project_name)
         return fetcher, project
 
     def is_a_new_project_version(self, project, data):
@@ -69,17 +69,14 @@ class Monitor:
     def save_analyzed_project(self, data):
         if not data:
             return {}
-        project = self._query(Package).filter_by(name = data['name']).first()
+        project = self.db.filter_by_name(Package, data['name'])
         if not project:
-            project = Package.save(self.session, data)
+            project = Package.save(self.db, data)
         if project:
-            project = Package.update(self.session, project, data)
+            project = Package.update(self.db, project, data)
 
         for analyzer, result in data['results'].items():
-            Analysis.save(self.session, data, analyzer, result, project.versions[-1])
-
-    def _query(self, arg):
-        return self.session.query(arg)
+            Analysis.save(self.db, data, analyzer, result, project.versions[-1])
 
 
     @staticmethod
@@ -95,8 +92,8 @@ def daemon():
     """Entry point to the monitor module."""
     # TODO: improve with start/stop system
     queues = kiskadee.queue.Queues()
-    session = kiskadee.database.Database().session
-    monitor = Monitor(session, queues)
+    db = kiskadee.database.Database()
+    monitor = Monitor(db, queues)
     runner = Runner(queues)
     monitor_process = Process(
             target=monitor.start,
diff --git a/kiskadee/runner.py b/kiskadee/runner.py
index dfe02a0..0dee08a 100644
--- a/kiskadee/runner.py
+++ b/kiskadee/runner.py
@@ -22,7 +22,7 @@ class Runner:
         self.fetcher = None
         self.project = None
 
-    def runner(self, queues):
+    def runner(self):
         """Run static analyzers.
 
         Continuously dequeue packages from `analyses_queue` and call the
diff --git a/kiskadee/tests/__init__.py b/kiskadee/tests/__init__.py
index 2165cb9..296e655 100644
--- a/kiskadee/tests/__init__.py
+++ b/kiskadee/tests/__init__.py
@@ -1 +1,13 @@
 """kiskadee test suite."""
+from kiskadee import model
+
+
+def clean_test_db(db, metadata):
+    """Clean test database to run tests independently."""
+    #  The number of openend sessions is limited by the operational system.
+    # If we open too much connections, the database will lock the tests
+    # execution.
+    db.session.close_all()
+    metadata.drop_all(db.engine)
+    metadata.create_all(db.engine)
+    model.Analyzer.create_analyzers(db)
diff --git a/kiskadee/tests/api/test_api.py b/kiskadee/tests/api/test_api.py
index 1ef5b8a..cff7f1b 100644
--- a/kiskadee/tests/api/test_api.py
+++ b/kiskadee/tests/api/test_api.py
@@ -3,9 +3,9 @@ import unittest
 from unittest.mock import MagicMock
 
 import kiskadee
-from kiskadee.monitor import Monitor
 import kiskadee.api.app
 import kiskadee.fetchers.example
+import kiskadee.database
 
 
 class ApiTestCase(unittest.TestCase):
@@ -14,16 +14,14 @@ class ApiTestCase(unittest.TestCase):
     def setUpClass(cls):
         kiskadee.api.app.kiskadee.testing = True
         cls.app = kiskadee.api.app.kiskadee.test_client()
+        cls.db = kiskadee.api.app.db = MagicMock()
 
     def setUp(self):
         self.fetcher = kiskadee.model.Fetcher(name='kiskadee-fetcher')
         self.queues = kiskadee.queue.Queues()
 
     def test_get_fetchers(self):
-        kiskadee.api.app.kiskadee_db_session = MagicMock()
-        kiskadee.api.app.kiskadee_db_session().query().all = MagicMock(
-                return_value=[self.fetcher]
-                )
+        self.db.session.query().all = MagicMock(return_value=[self.fetcher])
         response = self.app.get("/fetchers")
         response_data = json.loads(response.data.decode("utf-8"))
         self.assertIn("fetchers", response_data)
@@ -33,23 +31,18 @@ class ApiTestCase(unittest.TestCase):
             )
 
     def test_get_analysis_as_json(self):
-        package = kiskadee.model.Package(name='mocked-package', id=1)
-        version = kiskadee.model.Version(number='1.0.0', id=1, package_id=1)
         analysis = kiskadee.model.Analysis(
                 id=1, analyzer_id=1, version_id=1,
                 raw='analysis result: foo'
                 )
 
-        kiskadee.api.app.kiskadee_db_session = MagicMock()
-        Monitor(kiskadee.api.app.kiskadee_db_session(), self.queues)
-        db_session = kiskadee.api.app.kiskadee_db_session()
-        db_session.query(kiskadee.model.Package)\
-                  .filter_by().id = MagicMock()
-
-        db_session.query(kiskadee.model.Version)\
-                  .filter_by().id = MagicMock()
-        db_session.query().options()\
-                  .filter().all = MagicMock(return_value=[analysis])
+        self.db.filter_by_name = MagicMock()
+        self.db.session.query(kiskadee.model.Package)\
+            .filter_by().id = MagicMock()
+        self.db.session.query(kiskadee.model.Version)\
+            .filter_by().id = MagicMock()
+        self.db.session.query().options()\
+            .filter().all = MagicMock(return_value=[analysis])
 
         response = self.app.get("/analysis/mocked-package/1.0.0")
         response_data = json.loads(response.data.decode("utf-8"))
@@ -61,10 +54,7 @@ class ApiTestCase(unittest.TestCase):
                 id=1, analyzer_id=1, version_id=1,
                 raw={'results': 'first analysis results'}
                 )
-
-        kiskadee.api.app.kiskadee_db_session().query().get = MagicMock(
-                return_value=analysis
-                )
+        self.db.get = MagicMock(return_value=analysis)
         response = self.app.get("/analysis/kiskadee-package/7.23/1/results")
         response_data = json.loads(response.data.decode("utf-8"))
         self.assertIn("analysis_results", response_data)
diff --git a/kiskadee/tests/integration/test_monitor.py b/kiskadee/tests/integration/test_monitor.py
index 2369499..9691ca2 100644
--- a/kiskadee/tests/integration/test_monitor.py
+++ b/kiskadee/tests/integration/test_monitor.py
@@ -1,16 +1,13 @@
 import unittest
 from unittest.mock import MagicMock
-from sqlalchemy.orm import sessionmaker
 
-from kiskadee import model
 from kiskadee.monitor import Monitor
 from kiskadee.queue import Queues
-from kiskadee.model import Package, Analyzer, Report, Analysis, Fetcher
+from kiskadee.model import Package, Fetcher
 import kiskadee.queue
 import kiskadee.fetchers.debian
 import kiskadee.fetchers.anitya
 import kiskadee.fetchers.example
-from kiskadee.database import Database
 
 
 class MonitorTestCase(unittest.TestCase):
@@ -23,11 +20,10 @@ class MonitorTestCase(unittest.TestCase):
             klass()
 
         self.example_fetcher = kiskadee.fetchers.example.Fetcher()
-        self.session = MagicMock()
+        self.db = MagicMock()
 
         queues = Queues()
-        self.monitor = Monitor(self.session, queues)
-        self.session.query = MagicMock(side_effect=mocked_models)
+        self.monitor = Monitor(self.db, queues)
 
         self.data1 = {
                 'name': 'curl',
@@ -60,9 +56,8 @@ class MonitorTestCase(unittest.TestCase):
         self.assertIn("fetcher", second_monitored_project)
 
     def test_send_project_to_runner(self):
-        fetcher = kiskadee.model.Fetcher(name='example')
-        project = kiskadee.model.Package(name='project1',
-                fetcher_id=fetcher.id)
+        fetcher = Fetcher(name='example')
+        Package(name='project1', fetcher_id=fetcher.id)
         self.monitor.get_fetcher_and_project = MagicMock(
                 return_value=[fetcher, {}]
                 )
@@ -70,8 +65,7 @@ class MonitorTestCase(unittest.TestCase):
                 return_value=True
                 )
         self.monitor.send_project_to_runner(self.data1)
-        self.assertEqual(self.monitor.queues.dequeue_analysis(),
-                self.data1)
+        self.assertEqual(self.monitor.queues.dequeue_analysis(), self.data1)
 
         if __name__ == '__main__':
             unittest.main()
diff --git a/kiskadee/tests/integration/test_runner.py b/kiskadee/tests/integration/test_runner.py
index 3cd646f..f8ed25b 100644
--- a/kiskadee/tests/integration/test_runner.py
+++ b/kiskadee/tests/integration/test_runner.py
@@ -3,6 +3,7 @@ This integration tests needs docker engine be running and accessible
 by the user that is executing the tests. It also needs selinux running in
 a permissive mode (setenforce 0)
 """
+
 import unittest
 import re
 from unittest.mock import MagicMock
@@ -13,6 +14,7 @@ import kiskadee.monitor
 import kiskadee.fetchers.example
 import kiskadee.analyzers
 
+
 class RunnerTestCase(unittest.TestCase):
 
     """Docstring for AnalyzersTestCase. """
@@ -40,18 +42,19 @@ class RunnerTestCase(unittest.TestCase):
     def test_run_a_single_analyzer(self):
         self.runner.project = self.project
         self.runner.fetcher = self.runner.import_project_fetcher()
-        source_path = self.runner.get_project_code_path()
+        self.runner.get_project_code_path()
         analyzer = self.runner.fetcher.analyzers()[0]
         self.assertIsNotNone(re.search('.*cppcheck.*', analyzer))
         self.assertIsNone(re.search('.*pylint.*', analyzer))
 
     def test_analysis_an_incoming_monitor_project(self):
-        self.session = MagicMock()
-        self.session.query().filter_by().first = MagicMock(return_value={})
-        self.monitor = kiskadee.monitor.Monitor(self.session, self.queues)
+        self.db = MagicMock()
+        self.db.filter_by_name = MagicMock(return_value={})
+        self.monitor = kiskadee.monitor.Monitor(self.db, self.queues)
         self.monitor.send_project_to_runner(self.project)
         incoming_project = self.runner.queues.dequeue_analysis()
         self.assertEqual(self.project, incoming_project)
 
+
 if __name__ == '__main__':
     unittest.main()
diff --git a/kiskadee/tests/units/test_model.py b/kiskadee/tests/units/test_model.py
index aba56e7..f542aaa 100644
--- a/kiskadee/tests/units/test_model.py
+++ b/kiskadee/tests/units/test_model.py
@@ -1,87 +1,85 @@
 import unittest
 from sqlalchemy import exc
-from sqlalchemy.orm import sessionmaker
 
+import kiskadee
 from kiskadee import model
 from kiskadee.database import Database
 
 
 class ModelTestCase(unittest.TestCase):
 
+    @classmethod
+    def setUpClass(cls):
+        cls.db = Database('db_test')
+
     def setUp(self):
-        self.engine = Database('db_test').engine
-        Session = sessionmaker(bind=self.engine)
-        self.session = Session()
-        model.Base.metadata.create_all(self.engine)
-        model.Analyzer.create_analyzers(self.session)
+        kiskadee.tests.clean_test_db(self.db, model.Base.metadata)
+        self.package = model.Package(name='python-kiskadee')
+        self.version = model.Version(number='1.0-rc1')
         self.fetcher = model.Fetcher(
               name='kiskadee-fetcher', target='university'
             )
-        self.package = model.Package(name='python-kiskadee')
-        self.version = model.Version(number='1.0-rc1')
+        self.db.session.add(self.fetcher)
+        self.db.session.commit()
         self.fetcher.packages.append(self.package)
         self.package.versions.append(self.version)
-        self.session.add(self.package)
-        self.session.add(self.fetcher)
-        self.session.add(self.version)
+        self.db.session.add(self.package)
+        self.db.session.add(self.fetcher)
+        self.db.session.add(self.version)
 
         self.analysis = model.Analysis(
                 analyzer_id=1,
                 version_id=1,
                 raw=""
                 )
-        self.session.add(self.analysis)
+        self.db.session.add(self.analysis)
         self.report = model.Report(
                 analysis_id=1,
         )
-        self.session.add(self.report)
-        self.session.commit()
-
-    def tearDown(self):
-        self.session.close()
-        model.Base.metadata.drop_all()
+        self.db.session.add(self.report)
+        self.db.session.commit()
 
     def test_query_fetcher(self):
-        fetchers = self.session.query(model.Fetcher).all()
+        fetchers = self.db.session.query(model.Fetcher).all()
         self.assertEqual(fetchers, [self.fetcher])
 
     def test_query_package(self):
-        packages = self.session.query(model.Package).all()
+        packages = self.db.session.query(model.Package).all()
         self.assertEqual(packages, [self.package])
 
     def test_query_version(self):
-        versions = self.session.query(model.Version).all()
+        versions = self.db.session.query(model.Version).all()
         self.assertEqual(versions, [self.version])
 
     def test_query_report(self):
-        reports = self.session.query(model.Report).all()
+        reports = self.db.session.query(model.Report).all()
         self.assertEqual(reports, [self.report])
 
     def test_add_fetcher(self):
-        fetchers = self.session.query(model.Fetcher).all()
+        fetchers = self.db.session.query(model.Fetcher).all()
         self.assertEqual(len(fetchers), 1)
-        self.session.add(model.Fetcher(name='foo', target='bar'))
-        fetchers = self.session.query(model.Fetcher).all()
+        self.db.session.add(model.Fetcher(name='foo', target='bar'))
+        fetchers = self.db.session.query(model.Fetcher).all()
         self.assertEqual(len(fetchers), 2)
 
     def test_add_version_without_package(self):
         version = model.Version(number='3.1')
-        self.session.add(version)
+        self.db.session.add(version)
         with self.assertRaises(exc.IntegrityError):
-            self.session.commit()
+            self.db.session.commit()
 
     def test_add_report_without_analysis(self):
         report = model.Report(
         )
-        self.session.add(report)
+        self.db.session.add(report)
         with self.assertRaises(exc.IntegrityError):
-            self.session.commit()
+            self.db.session.commit()
 
     def test_add_package_without_fetcher(self):
         package = model.Package(name='foo-bar')
-        self.session.add(package)
+        self.db.session.add(package)
         with self.assertRaises(exc.IntegrityError):
-            self.session.commit()
+            self.db.session.commit()
 
     def test_unique_package_in_fetcher(self):
         package_1 = model.Package(name='foo-bar')
@@ -89,7 +87,7 @@ class ModelTestCase(unittest.TestCase):
         self.fetcher.packages.append(package_1)
         self.fetcher.packages.append(package_2)
         with self.assertRaises(exc.IntegrityError):
-            self.session.commit()
+            self.db.session.commit()
 
     def test_unique_version_for_package(self):
         package_version_1 = model.Version(number='1.0')
@@ -97,10 +95,10 @@ class ModelTestCase(unittest.TestCase):
         self.package.versions.append(package_version_1)
         self.package.versions.append(package_version_2)
         with self.assertRaises(exc.IntegrityError):
-            self.session.commit()
+            self.db.session.commit()
 
     def test_compose_kiskadee_source(self):
-        _analyzer = self.session.query(model.Analyzer)\
+        _analyzer = self.db.session.query(model.Analyzer)\
                     .filter(model.Analyzer.name == "cppcheck").first()
         package = model.Package(
                 name='bla',
@@ -126,11 +124,11 @@ class ModelTestCase(unittest.TestCase):
     def test_save_several_analysis(self):
 
         _analyzer1 = (
-                self.session.query(model.Analyzer)
+                self.db.session.query(model.Analyzer)
                 .filter(model.Analyzer.name == "cppcheck").first()
                 )
         _analyzer2 = (
-                self.session.query(model.Analyzer)
+                self.db.session.query(model.Analyzer)
                 .filter(model.Analyzer.name == "flawfinder").first()
                 )
 
@@ -146,9 +144,9 @@ class ModelTestCase(unittest.TestCase):
         self.fetcher.packages.append(package)
         package.versions.append(package_version)
 
-        self.session.add(package)
-        self.session.add(package_version)
-        self.session.commit()
+        self.db.session.add(package)
+        self.db.session.add(package_version)
+        self.db.session.commit()
 
         package_analysis1 = model.Analysis(
                 raw="<>",
@@ -161,12 +159,12 @@ class ModelTestCase(unittest.TestCase):
                 version_id=package_version.id
                 )
 
-        self.session.add(package_analysis1)
-        self.session.add(package_analysis2)
-        self.session.commit()
+        self.db.session.add(package_analysis1)
+        self.db.session.add(package_analysis2)
+        self.db.session.commit()
 
         saved_package = (
-                self.session.query(model.Package)
+                self.db.session.query(model.Package)
                 .filter(model.Package.name == 'bla').first()
                 )
         analysis = saved_package.versions[-1].analysis
diff --git a/kiskadee/tests/units/test_runner.py b/kiskadee/tests/units/test_runner.py
new file mode 100644
index 0000000..502c969
--- /dev/null
+++ b/kiskadee/tests/units/test_runner.py
@@ -0,0 +1,18 @@
+import unittest
+
+import kiskadee.fetchers.example
+import kiskadee.runner
+
+
+class RunnerTestCase(unittest.TestCase):
+
+    def setUp(self):
+        self.queues = kiskadee.queue.Queues()
+        self.runner = kiskadee.runner.Runner(self.queues)
+
+    def test_path_to_uncompressed_source(self):
+
+        self.runner.fetcher = kiskadee.fetchers.example.Fetcher()
+        self.runner.project = {'name': 'test'}
+        uncompressed_source_path = self.runner.get_project_code_path()
+        self.assertIsNotNone(uncompressed_source_path)

